### clp_ga_generation.py
from clp_ga_mutation import *
from clp_ga_selektion import *
from clp_ga_crossing_over import *
from clp_ga_pool import *

### ===== Generationen-folge =====
def generationenFolge(pool, anzahl):
    for i in range(anzahl):
        pool=generation(pool)
    return pool

### ----- generation -----
# Fuehrt einen Generationenschritt aus.
# es werden alle einmal mutiert und die besten aus den vorher vorhandenen und 
# den mutierten ausgewaehlt.
def generation(pool):
    mutiert=mutation(pool)
    cross=crossingOver(1,mutiert)#len(pool),mutiert)
    selektiert=selektion(cross, len(pool), 0.50)
    return selektiert

### === Tests ===
##contListe0=[[0, [40,10,20,30,40,10,80,30,20,30,10]],
##                 [100,[]],[100,[40]],[160,[50]],[60,[50]]]
##contListe1=[[0, [40,10,20,30,40,50,80,30]],
##                 [100,[20]],[100,[40]],[160,[50,30,10]],[60,[10]]]
##contListe2=[[0, [40,10,20,30,40,50,80,30]],
##                 [100,[20,40]],[100,[90]],[160,[50,10]],[60,[60]]]
##contListe3=[[0, [40,20,30,60,50,30]],
##                 [100,[20,40,10]],[100,[90]],[160,[80,50,10]],[60,[40]]]
##pool=[contListe0,contListe1,contListe2,contListe3]

##print('eine Generation',generation(pool))
##def AusgabeGenerationenFolge():
##    gF=generationenFolge(pool,100)
##    print(gF[0], bewerte(gF[0]))
##
##AusgabeGenerationenFolge()
