### clp_ga_mutation.py

from random import randint
from random import seed

### ===== Mutation =====
# Bei der Mutation wird ein zufaellig gewaehltes Stueck
# aus einem zufaellig gewaehlten Container entnommen und
# in einen zufaellig gewaehlten anderen getan.
def mutation(pool):
    alle=[]
    for individuum in pool:
        mutiert=mutiere(
            randint(0,len(individuum)-1),
            randint(0,len(individuum)-1),
            individuum)
        alle.append(mutiert)
        alle.append(individuum)
    return alle

### ----- mutiere -----
# Fuehrt die Mutation durch
# zahl x zahl x liste --> liste
def mutiere(vonNr, nachNr, contListe):
    ##print(vonNr,nachNr,'von -> nach\n')
    if len(contListe)==1: # sinnlos!
        return contListe
    if vonNr==nachNr: # sinnlos, aendern
        nachNr=vonNr+1
    if nachNr==len(contListe): # geht nicht!
        nachNr=vonNr
        vonNr=0
    if leer(vonNr, contListe): # geht nicht!
        return contListe
    vonContainer=contListe[vonNr]
    stueckNr=randint(0,len(vonContainer[1])-1)
    stueck=vonContainer[1].pop(stueckNr) # holen und entfernen
    if contListe[nachNr][0]<sum(contListe[nachNr][1])+stueck:
        vonContainer[1].append(stueck)
        return contListe
    contListe[nachNr][1].append(stueck)
    ##print(vonNr,nachNr,stueckNr,'\n',contListe,'\n')
    return contListe
     
### ----- leer -----
# prueft, ob der container mit der uebergebenen nummer leer ist.
# nr: 0 .. n-1
def leer(nr, containerListe):
    ##print(nr)
    return len(containerListe[nr][1])==0


### ===== Test =====
##def AusgabeMutiere(contListe):
##    seed()
##    print(contListe)
##    anzahlContainer=len(contListe)
##    mutiert=mutiere(randint(0,anzahlContainer-1),
##                    randint(0,anzahlContainer-1),
##                    contListe)
##    print('mutiert\n',mutiert,'\n')
##containerListe0=[[0, [10,20,30,40,10,20,30,40,50,80,10,20,30,50,80,10,20,
##                      30,40,10,20,30,40,50,80,10,20,30,40,10,20,30,40,50,80]],
##                 [100,[]],[100,[]],[160,[]],[60,[]]]
##AusgabeMutiere(containerListe0)

##containerListe1=[[0, [40,10,20,30,40,50,80,30]],
##                 [100,[20]],[100,[40]],[160,[50,30,10]],[60,[10]]]
##AusgabeMutiere(containerListe1)

##containerListe2=[[0, [40,10,20,30,40,50,80,30]],
##                 [100,[20,40]],[100,[90]],[160,[50,10]],[60,[60]]]
##AusgabeMutiere(containerListe2)

##def AusgabeMutation(pool):
##    seed()
##    for contListe in pool:
##        print(contListe)
##    print()
##    mutierte=mutation(pool)
##    for contListe in mutierte:
##        print(contListe)
##    print()
##
##AusgabeMutation([containerListe1,containerListe2])
